<?php
/*
	Plugin Name: Gravity Forms Klick Tipp Manager Premium
	Description: Integrieren Sie GravityForms mit Klick-Tipp
	Author: KlickTipp-Solutions.de
	Author URI: https://www.klicktipp-solutions.de
	Plugin URI: https://www.klicktipp-solutions.de/
	Version: 1.7.5
*/
//set_site_transient( 'update_plugins', null );
define( "GF_KLICK_TIPP_MANAGER_PREMIUM_PLUGIN_URL", plugins_url() . "/" . basename( dirname( __FILE__ ) ) );
define( "GF_KLICK_TIPP_MANAGER_PREMIUM_PLUGIN_DIR", WP_PLUGIN_DIR . "/" . basename( dirname( __FILE__ ) ) );

define( 'EDD_GF_KLICK_TIPP_MANAGER_PREMIUM_STORE_URL', 'https://www.klicktipp-solutions.de' );
define( 'EDD_GF_KLICK_TIPP_MANAGER_PREMIUM_ITEM_ID', '3641' );
define( 'EDD_GF_KLICK_TIPP_MANAGER_PREMIUM_VERSION',  '1.7.5' );

if ( ! class_exists( 'EDD_SL_Plugin_Updater' ) ) {
	// load our custom updater
	include dirname( __FILE__ ) . '/EDD_SL_Plugin_Updater.php';
}

if ( ! class_exists( 'GF_Klicktipp_Contacts_List_Shortcode' ) ) {
	// include shortcode class to display contacts list
	require_once 'inc/class-gf-klicktipp-contacts-list-shortcode.php';
}
if ( ! class_exists( 'GF_KlickTipp_Manager_Premium_Save_Cookie' ) ) {
	require_once 'inc/class-gf-klicktipp-manager-premium-save-cookie.php';
}

// include button to add shortcode via editor
require_once 'inc/class-gf-ktm-editor-btn.php';

// Include Logging Class
include dirname( __FILE__ ) . '/inc/class-gf-ktm-logs.php';

function edd_sl_gfklicktipp_manager_premium_plugin_updater() {
	if ( class_exists( 'GFKlickTippManagerPremium' ) ) {
		// retrieve our license key from the DB
		$license_key = gfklicktipp_manager_premium_feed_addon()->get_plugin_setting( 'license_key' );

		// setup the updater
		$edd_updater = new EDD_SL_Plugin_Updater(
			EDD_GF_KLICK_TIPP_MANAGER_PREMIUM_STORE_URL,
			__FILE__,
			array(
				'version'  => EDD_GF_KLICK_TIPP_MANAGER_PREMIUM_VERSION,
				'license'  => $license_key,
				'item_id' => EDD_GF_KLICK_TIPP_MANAGER_PREMIUM_ITEM_ID,
				'author'  => 'IcosMedia'
			)
		);
	}
}
add_action( 'admin_init', 'edd_sl_gfklicktipp_manager_premium_plugin_updater' );

add_action( 'gform_loaded', array( 'GF_Klick_Tipp_Manager_Premium_Bootstrap', 'load' ), 5 );
class GF_Klick_Tipp_Manager_Premium_Bootstrap {
	public static function load() {
		if ( ! method_exists( 'GFForms', 'include_feed_addon_framework' ) ) {
			return;
		}
		if ( ! class_exists( 'KlicktippConnector' ) ) {
			require_once 'klicktipp.api.inc';
		}

		require_once 'inc/class-gf-klicktipp-manager-premium-admin-field-option.php';
		require_once 'inc/class-gf-klicktipp-manager-premium-prefill-fields.php';

		require_once 'class-gfklicktippmanagerpremium.php';
		GFAddOn::register( 'GFKlickTippManagerPremium' );
	}
}
function gfklicktipp_manager_premium_feed_addon() {
	return GFKlickTippManagerPremium::get_instance();
}
function gf_klicktipp_manager_premiump_connect_api() {
	$settings = get_option( 'gravityformsaddon_gfklicktippmanagerpremium_settings' );;
	$connector = new KlicktippConnector();
	$logged_in = $connector->login( $settings['username'], $settings['password'] );
	if ( ! $logged_in ) {
		return array( 'error'=>$connector->get_last_error() );
	} else {
		return array( 'success' => $connector );
	}
}
