<?php
if ( ! class_exists( 'GF_Klicktipp_Contacts_List_Shortcode' ) ) {
	class GF_Klicktipp_Contacts_List_Shortcode {
		private $contact_count = 0;
		private $subscribers;

		public function __construct() {
			add_action( 'wp_enqueue_scripts', array( $this, 'add_scripts' ) );
			add_shortcode( 'klicktipp-manager', array( $this, 'klicktipp_contacts_list_shortcode' ) );

			add_action( 'wp_ajax_get_klicktipp_subscribers', array( $this, 'get_subscribers' ) );
			add_action( 'wp_ajax_nopriv_get_klicktipp_subscribers', array( $this, 'get_subscribers' ) );
		}

		public function add_scripts() {
			wp_enqueue_style( 'datatables', GF_KLICK_TIPP_MANAGER_PREMIUM_PLUGIN_URL . '/css/datatables.min.css' );
			wp_enqueue_script( 'datatables', GF_KLICK_TIPP_MANAGER_PREMIUM_PLUGIN_URL . '/js/datatables.min.js', array( 'jquery' ) );
		}

		public function klicktipp_contacts_list_shortcode( $atts ) {
			if ( class_exists( 'KlicktippConnector' ) ) {
				delete_transient( 'klick_tipp_subscribers_index' );
				$atts = shortcode_atts( array( 'updatepage' => 'false', 'lastcolumn'=>'', 'password' => '' ), $atts );

				$password = $atts['password'];
				if ( ! empty(  $password ) ) {
					if ( isset( $_COOKIE['ktm_table_password'] ) && $_COOKIE['ktm_table_password'] === $password  ) {
						//nothing to do
					} else {
						// show form to enter password
						echo '<form action="" method="post">';
						wp_nonce_field( 'ktm_table_password_nonce', 'ktm_table_password_nonce_field' );
						echo '<label> Please enter password. </label>';
						echo '<input type="text" name="ktm_table_password" >&nbsp;&nbsp;';
						echo '<button type="submit" value="submit" name="ktm_table_password_submit" >Submit</button>';
						echo '</form>';
						return;
					}
				}

				$lastcolumn = explode( ':', $atts['lastcolumn'] );
				$lastcolumn_fieldname = !empty($lastcolumn[1])?$lastcolumn[1]:'fieldCompanyName';
				$connection = gf_klicktipp_manager_premiump_connect_api();
				if ( ! isset( $connection['success'] ) ) {
					$tags = array( $connection['error'] );
				} else {
					$connector = $connection['success'];
					$tags = $connector->tag_index();
					if ( ! $tags ) {
						$tags =  array( $connector->get_last_error() );
						$connector->logout();
					}
				}
				ob_start();
				?>
			<style>
				table.dataTable thead th, table.dataTable tfoot th{
					padding-left: 8px;
				}
			</style>

			<div class="klicktipp-search-form">
				<div>
					<label> Kontakte suchen  <input type="radio" checked="checked" id="kt-search-by-email" name="kt-search-by">E-Mail &nbsp;&nbsp;<input id="kt-search-by-tag" type="radio" name="kt-search-by">Tag</label>
					<input style="max-width: 350px;" type="email" id="kt-email-search-field">
					<select style="display:none" id="kt-tag-search-field">
						<option>Wähle einen Tag aus</option>
					<?php
				foreach ( $tags as $tag_id => $tag_name ) {
					echo '<option value="' . $tag_id . '">' . $tag_name . '</option>';
				} ?>
					</select>
				</div>
				<a style=" border: 1px solid #bbb;padding: 10px 20px;border-radius: 10px;margin: 20px 0px 40px 0px;display: inline-block;" href="javascript:void(0)" id="kt-search-btn">Suche</a>
				<a style=" border: 1px solid #bbb;padding: 10px 20px;border-radius: 10px;margin: 20px 0px 40px 0px;display: inline-block;" href="javascript:void(0)" id="kt-search--clr-btn">Suche löschen</a>
			</div>
			<table  style="width:100%"  id="kt-subscribers-table" class="display">
				<thead>
					<tr>
						<th>Vorname</th>
						<th>Name</th>
						<th>E-Mail</th>
						<?php echo !empty($lastcolumn[0])?'<th>'.$lastcolumn[0].'</th>': '<th>Firma</th>'; ?>
						<th>Aktion</th>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<th>Vorname</th>
						<th>Name</th>
						<th>E-Mail</th>
						<?php echo !empty($lastcolumn[0])?'<th>'.$lastcolumn[0].'</th>': '<th>Firma</th>'; ?>
						<th>Aktion</th>
					</tr>
					<tfoot>
			</table>

			<script>
			jQuery(document).ready( function () {
				var kt_ajax_url = "<?php echo admin_url( 'admin-ajax.php?action=get_klicktipp_subscribers&lastcolumn_fieldname='.$lastcolumn_fieldname.'&updatepage=' . $atts['updatepage'] ); ?>";
				var kt_subscribers_table = jQuery('#kt-subscribers-table').DataTable({
					searching: false,
    				ordering:  false,
					processing: true,
					scrollX: true,
					serverSide: true,
					ajax: kt_ajax_url,
					language: {
						"emptyTable": "No contacts found",
						"info":           "Es werden _START_ bis _END_ von _TOTAL_ Einträgen angezeigt.",
						"infoEmpty":      "Es werden 0 bis 0 von 0 Einträgen angezeigt.",
						"infoFiltered":   "(filtered from _MAX_ total entries)",
						"thousands":      ".",
						"lengthMenu":     "Zeige _MENU_ Einträge",
						"loadingRecords": "Loading...",
						"processing":     "Einträge werden geladen...",
						"search":         "Search:",
						"zeroRecords":    "No matching records found",
						"paginate": {
							"first":      "First",
							"last":       "Last",
							"next":       "Weiter",
							"previous":   "Zurück"
						},
						"aria": {
							"sortAscending":  ": activate to sort column ascending",
							"sortDescending": ": activate to sort column descending"
						}
						}
				});
				jQuery('body').on('click','#kt-search-by-email',function(){
					jQuery("#kt-tag-search-field").hide();
					jQuery("#kt-email-search-field").fadeIn();
				})
				jQuery('body').on('click','#kt-search-by-tag',function(){
					jQuery("#kt-email-search-field").hide();
					jQuery("#kt-tag-search-field").fadeIn();
				})
				jQuery('body').on('click','#kt-search--clr-btn',function(){
					kt_subscribers_table.ajax.url( kt_ajax_url)
					kt_subscribers_table.clear().draw();
					jQuery("#kt-tag-search-field").val('');
					jQuery("#kt-email-search-field").val('');
				})
				jQuery('body').on('keypress','#kt-email-search-field',function(e){
					//on enter press
					if(e.which == 13){
						jQuery('#kt-search-btn').trigger('click');
					}
				})

				jQuery('body').on('click','#kt-search-btn',function(){
					if( jQuery('#kt-search-by-email').is(':checked') ){
						var value = jQuery('#kt-email-search-field').val();
						var param = '&email='+encodeURIComponent( value );
					} else if( jQuery('#kt-search-by-tag').is(':checked') ) {
						var value = jQuery('#kt-tag-search-field').val();
						var param = '&tag='+encodeURIComponent( value );
					}

					if( value!=''){
						kt_subscribers_table.ajax.url( kt_ajax_url + param)
						kt_subscribers_table.clear().draw();
					}
				})
			} );
			</script>

			<?php
			$output = ob_get_contents();
			ob_end_clean();
			return $output;
			} else {
				return 'Please make sure you have installed klick tipp addon';
			}
		}

		public function get_subscribers() {
			$connection = gf_klicktipp_manager_premiump_connect_api();
			$message = '';
			if ( ! isset( $connection['success'] ) ) {
				$message =   $connection['error'];
			} else {
				$connector = $connection['success'];
				// if searched by email
				if ( isset( $_GET['email'] ) ) {
					$subscribers_index = $connector->subscriber_search( $_GET['email'] );
				} elseif ( isset( $_GET['tag'] ) ) {
					$subscribers_index = $connector->subscriber_tagged( $_GET['tag'] );
					if ( is_array( $subscribers_index ) ) {
						$subscribers_index = array_keys( $subscribers_index );
					}
				} else {
					$this->send_ajax_response( $_GET['draw'], 0, 0, array() );
					// $subscribers_transient = get_transient( 'klick_tipp_subscribers_index' );
					// if ( ! $subscribers_transient ) {
					// 	$subscribers_index = $connector->subscriber_index();
					// 	if ( ! $subscribers_index ) {
					// 		$message =  $connector->get_last_error();
					// 		$connector->logout();
					// 	} else {
					// 		set_transient( 'klick_tipp_subscribers_index', $subscribers_index );
					// 	}
					// } else {
					// 	$subscribers_index = $subscribers_transient;
					// }
				}
			}


			//var_dump( $subscribers_index );die;
			if ( $message != '' ) {
				$this->send_ajax_response( $_GET['draw'], 0, 0, array( array( '', '', $message, '', '' ) ) );
				//return 'Some Error Occurred:' . $message;
			}
			if ( empty( $subscribers_index ) ) {
				// 'No subscriber found';
				$this->send_ajax_response( $_GET['draw'], 0, 0, array() );
			}
			$updatepage = $_GET['updatepage'];
			if ( is_array( $subscribers_index ) ) {
				$subscribers = array_slice( $subscribers_index, $_GET['start'], $_GET['length'] );
			} else {
				$subscribers_index = (array)$subscribers_index;
				$subscribers = $subscribers_index;
			}


			$rows = array();
			// Start Subscriber list display
			foreach ( $subscribers as $subscriber_id ) {
				if ( $updatepage != 'false' ) {
					$updatepage_link = add_query_arg( 'klicksub_id', $subscriber_id, $updatepage );
				}
				$subscriber = $connector->subscriber_get( $subscriber_id );
				$lastcolumn_value = isset($subscriber->{$_GET['lastcolumn_fieldname']})?$subscriber->{$_GET['lastcolumn_fieldname']}: '';
				$rows[] = array(
					$subscriber->fieldFirstName,
					$subscriber->fieldLastName,
					$subscriber->email,
					$lastcolumn_value,
					'<a href="' . $updatepage_link . '">Bearbeiten</a>'
				);
			}

			$connector->logout();
			$this->send_ajax_response( $_GET['draw'], count( $subscribers_index ), count( $subscribers_index ), $rows );
		}

		public function send_ajax_response( $draw, $recordsFiltered, $recordsTotal, $data ) {
			$data = array(
				'draw'=>$draw,
				'recordsFiltered'=>$recordsFiltered,
				'recordsTotal'=>$recordsTotal,
				'data'=>$data
			);
			echo json_encode( $data );
			die;
		}
	}

	new GF_Klicktipp_Contacts_List_Shortcode();
}
