<?php

class GF_KlickTipp_Manager_Premium_Admin_Field_Option {
	private $klick_tipp_fields;
	function __construct() {
		add_action( 'gform_field_advanced_settings', array( $this, 'add_klick_tipp_field_drodown' ), 10, 2 ) ;
		add_action( 'gform_editor_js', array( $this, 'editor_script' ) );
		$this->klick_tipp_fields = $this->klick_tipp_fields();
	}

	function add_klick_tipp_field_drodown( $position, $form_id ) {

		$klick_tipp_field_options = $this->get_klick_tipp_field_options();
		//create settings on position 50 (right after Admin Label)
		if ( $position == 50 ) {
?>
			<!-- normal fields -->
			<li class="klick_tipp_field_setting field_setting">
				<label for="field_admin_label">
					<?php _e( "Klick-Tipp-Feld für automatische Befüllung auswählen", "gravityforms" ); ?>
					<?php //gform_tooltip( "form_field_encrypt_value" ) ?>
				</label>
				<select onchange="SetFieldProperty('klicktippField', this.value);" id="field_klick_tipp_field_id">
					<?php echo $klick_tipp_field_options; ?>
				</select>
			</li>
			<!--  Name Field -->
			<li class="klick_tipp_field_name_settings field_setting">
			<label for="field_admin_label">
					<?php _e( "Klick-Tipp-Feld für automatische Befüllung auswählen", "gravityforms" ); ?>
					<?php //gform_tooltip( "form_field_encrypt_value" ) ?>
				</label>
			<div>
					<table>
						<tr>
							<td><strong>Field</strong></td>
							<td><strong>Klick Tipp Field</strong></td>
						</tr>
						<tr>
							<td><label>Prefix</label></td>
							<td>
								<select onchange="SetFieldProperty('klicktippNamePrefix', this.value);" id="field_klick_tipp_name_prefix">
								<?php echo $klick_tipp_field_options; ?>
								</select>
							</td>
						</tr>
						<tr>
							<td><label>First</label></td>
							<td>
								<select onchange="SetFieldProperty('klicktippNameFirst', this.value);" id="field_klick_tipp_name_first">
								<?php echo $klick_tipp_field_options; ?>
								</select>
							</td>
						</tr>
						<tr>
							<td><label>Middle</label></td>
							<td>
								<select onchange="SetFieldProperty('klicktippNameMiddle', this.value);" id="field_klick_tipp_name_middle">
								<?php echo $klick_tipp_field_options; ?>
								</select>
							</td>
						</tr>
						<tr>
							<td><label>Last</label></td>
							<td>
								<select onchange="SetFieldProperty('klicktippNameLast', this.value);" id="field_klick_tipp_name_last">
								<?php echo $klick_tipp_field_options; ?>
								</select>
							</td>
						</tr>
						<tr>
							<td><label>Suffix</label></td>
							<td>
								<select onchange="SetFieldProperty('klicktippNameSuffix', this.value);" id="field_klick_tipp_name_suffix">
								<?php echo $klick_tipp_field_options; ?>
								</select>
							</td>
						</tr>
					</table>
				</div>
			</li>
			<?php
		}
	}

	function editor_script() {
?>
		<script type='text/javascript'>
			//binding to the load field settings event to initialize the checkbox
			jQuery(document).bind("gform_load_field_settings", function(event, field, form){
				var valid_types = new Array('simple','number','email','select', 'radio', 'checkbox', 'multiselect', 'text', 'textarea','hidden','phone','date','time','website');

                    if (jQuery.inArray(field['type'], valid_types) != -1) {
						jQuery(".klick_tipp_field_setting").css('display','list-item')

						if("klicktippField" in field ){
							jQuery("#field_klick_tipp_field_id option[value='"+field['klicktippField']+"']").prop('selected', true);
						}else{
							jQuery("#field_klick_tipp_field_id").prop('selectedIndex',0);
						}

                    }else if(field['type'] == 'name'){
						jQuery(".klick_tipp_field_name_settings").css('display','list-item')
						jQuery("#field_klick_tipp_name_prefix option[value='"+field['klicktippNamePrefix']+"']").attr('selected', true);
						jQuery("#field_klick_tipp_name_first option[value='"+field['klicktippNameFirst']+"']").attr('selected', true);
						jQuery("#field_klick_tipp_name_middle option[value='"+field['klicktippNameMiddle']+"']").attr('selected', true);
						jQuery("#field_klick_tipp_name_last option[value='"+field['klicktippNameLast']+"']").attr('selected', true);
						jQuery("#field_klick_tipp_name_suffix option[value='"+field['klicktippNameSuffix']+"']").attr('selected', true);
					}
			});
		</script>
		<?php
	}

	function get_klick_tipp_field_options() {
		$options ='<option value="">Wähle ein Feld aus</option>';
		$options .= '<option value="email">Email</option>';
		$fields = $this->klick_tipp_fields;
			foreach ( $fields as $fieldkey=>$field_name ) {
				$options .= '<option value="' . $fieldkey . '">' . $field_name . '</option>';
			}
		$options .= '<option value="sms_phone">SMS-Mobilnummer</option>';
		return $options;
	}

	function klick_tipp_fields(){
		$settings = get_option( 'gravityformsaddon_gfklicktippmanagerpremium_settings' );;
		$connector = new KlicktippConnector();
		$logged_in = $connector->login( $settings['username'], $settings['password'] );
		$message = '';

		if ( ! $logged_in ) {
			$fields =  array( $connector->get_last_error());
		}else {
			$fields = $connector->field_index();

			if ( ! $fields ) {
				$fields =  array( $connector->get_last_error());
			}
		}
		return $fields;
	}
}
new GF_KlickTipp_Manager_Premium_Admin_Field_Option();
