<?php
class GF_KlickTipp_Manager_Premium_Prefill_Fields {
	private $subscriber;
	function __construct() {
		add_filter( 'gform_pre_render', array( $this, 'maybe_prefill_form_fields' ) );
	}
	function maybe_prefill_form_fields( $form ) {
		if ( ! empty( $_GET['klicksub_id'] ) ) {
			$connection = gf_klicktipp_manager_premiump_connect_api();
			if ( ! isset( $connection['success'] ) ) {
				return $form;
			}else {
				$connector = $connection['success'];
				$subscriber = $connector->subscriber_get( $_GET['klicksub_id'] );
				$this->subscriber = $subscriber;
			}

			if ( ! empty ( $subscriber ) ) {
				foreach ( $form['fields'] as &$field ) {
					if ( $field->type == 'name' ) {

						foreach ( $field->inputs as  $key=>$name_type ) {

							if ( ( $name_type['id'] == $field['id' ] . '.2' ) &&  ! empty( $field['klicktippNamePrefix' ] ) ) {
								$field->inputs[$key]['name'] = 'klicktipp_name_prefix';
								add_filter( 'gform_field_value_klicktipp_name_prefix', array( $this, 'name_prefix' ), 10, 3 );
							} else if ( ( $name_type['id'] == $field['id' ] . '.3' ) &&  ! empty( $field['klicktippNameFirst' ] ) ) {
								$field->inputs[$key]['name'] = 'klicktipp_name_first';
								add_filter( 'gform_field_value_klicktipp_name_first', array( $this, 'name_first' ), 10, 3 );
							}else if ( ( $name_type['id'] == $field['id' ] . '.4' ) &&  ! empty( $field['klicktippNameMiddle' ] ) ) {
								$field->inputs[$key]['name'] = 'klicktipp_name_middle';
								add_filter( 'gform_field_value_klicktipp_name_middle', array( $this, 'name_middle' ), 10, 3 );
							}else if ( ( $name_type['id'] == $field['id' ] . '.6' ) &&  ! empty( $field['klicktippNameLast' ] ) ) {
								$field->inputs[$key]['name'] = 'klicktipp_name_last';
								add_filter( 'gform_field_value_klicktipp_name_last', array( $this, 'name_last' ), 10, 3 );
							}else if ( ( $name_type['id'] == $field['id' ] . '.8' ) &&  ! empty( $field['klicktippNameSuffix' ] ) ) {
								$field->inputs[$key]['name'] = 'klicktipp_name_suffix';
								add_filter( 'gform_field_value_klicktipp_name_suffix', array( $this, 'name_suffix' ), 10, 3 );
							}
						}
						$field->allowsPrepopulate = 1;
					} else if ( ! empty( $field['klicktippField' ] ) ) {
						$field->allowsPrepopulate = true;
						$key = sprintf( 'gwpd_%d_%d', $form['id'], $field['id'] );
						$field->inputName = $key;
						if ( $field->type == 'simple' ) {

							$value = date( 'Y-m-d H:i', $subscriber->{$field['klicktippField']} );
							$date = new DateTime($value, new DateTimeZone('UTC')); // KT's timezone
							$date->setTimezone(new DateTimeZone('Europe/Berlin'));
							$value = $date->format('Y-m-d H:i');

						} else if ( $field->type == 'date' && ! empty( $subscriber->{$field['klicktippField']} ) ) {
							$value='';
							if(  ! empty ( $subscriber->{$field['klicktippField']} ) ){
								$format = $this->get_date_format($field);
								$value = date( 'Y-m-d H:i', $subscriber->{$field['klicktippField']} );
								$date = new DateTime($value, new DateTimeZone('UTC')); // KT's timezone
								$date->setTimezone(new DateTimeZone('Europe/Berlin'));
								$value = $date->format($format);
								//$value = date( $format, ( $subscriber->{$field['klicktippField']} + ( 2 * 3600 ) ) );
							}
						} else if ( $field->type == 'time' && ! empty( $subscriber->{$field['klicktippField']} ) ) {
							$value='';
							if(  ! empty ( $subscriber->{$field['klicktippField']} ) ){
								$time_format = $this->get_time_format($field);
								$value = date( $time_format, $subscriber->{$field['klicktippField']} );
							}
						} else {
							$value = $subscriber->{$field['klicktippField']};
						}
						if ( ! empty( $value ) ) {
							add_filter( "gform_field_value_{$key}", function() use ($value){

								return $value;
							} );
						}
					}
				}
			}
		}

		return $form;
	}

	function name_prefix( $value, $field, $name  ) {
		return $this->subscriber->{$field['klicktippNamePrefix' ]};

	}
	function name_first( $value, $field, $name  ) {
		return $this->subscriber->{$field['klicktippNameFirst' ]};
	}
	function name_middle( $value, $field, $name  ) {
		return $this->subscriber->{$field['klicktippNameMiddle' ]};
	}
	function name_last( $value, $field, $name  ) {
		return $this->subscriber->{$field['klicktippNameLast' ]};
	}
	function name_suffix( $value, $field, $name  ) {
		return $this->subscriber->{$field['klicktippNameSuffix' ]};
	}

	function get_date_format($field){
		list( $format, $divider ) = $field['dateFormat'] ? array_pad( explode( '_', $field['dateFormat' ] ), 2, 'slash' ) : array( 'mdy', 'slash' );
		$dividers = array( 'slash' => '/', 'dot' => '.', 'dash' => '-' );
		$format = str_replace( 'y', 'Y', $format );
		$divider = $dividers[$divider];
		$format = implode( $divider, str_split( $format ) );
		return $format;
	}
	function get_time_format($field){
		if ( $field['timeFormat'] == '12' ) {
			$time_format = 'h:i A';
		}else {
			$time_format = 'H:i';
		}
		return $time_format;
	}

}

new GF_KlickTipp_Manager_Premium_Prefill_Fields();
