<?php
/**
 * Add a button to tinyMCE editors when eidting posts/pages.
 *
 * @since 2.9.22
 */

class GF_KTM_Premium_Editor_Btn {


	function __construct() {
		// Add a tinyMCE button to our post and page editor
		add_filter( 'media_buttons_context', array( $this, 'insert_form_tinymce_buttons' ) );
	}

	/**
	 * Output our tinyMCE field buttons
	 *
	 * @access public
	 * @since 2.8
	 * @return void
	 */
	public function insert_form_tinymce_buttons( $context ) {
		global $pagenow;

		if ( ! in_array( $pagenow, array( 'post.php', 'post-new.php' ) ) ) {
			return $context;
		}
		$html = '<style>
		span.ktm-insert-form{
			color:#888;
			font: 400 18px/1 dashicons;
			-webkit-font-smoothing: antialiased;
			-moz-osx-font-smoothing: grayscale;
			display: inline-block;
			width: 18px;
			height: 18px;
			vertical-align: text-top;
			margin: 0 2px 0 0;
		}

		#ktm-insert-form-modal-cnt label{
		font-size:14px;
		margin-right:15px;
		width:115px;
		display: inline-block;
		}
		.ktm-insert-form-icon{
		background:url('.GF_KLICK_TIPP_MANAGER_PREMIUM_PLUGIN_URL.'/css/ktm-editor-icon.png);
		width: 18px;
		height: 23px;
		display: inline-block;
		vertical-align: middle;
		background-repeat: no-repeat;
		}
        </style>';
		$html .= '<a href="#" class="button ktm-insert-form"><span class="ktm-insert-form-icon"></span> ' . __( 'KT Mananger', 'ninja-forms' ) . '</a>';

?>
         <div id="ktm-insert-form-modal" style="display:none;">
		 <div id="ktm-insert-form-modal-cnt" >
				<?php

			$connection = gf_klicktipp_manager_premiump_connect_api();
			if ( ! isset( $connection['success'] ) ) {
				$fields =array('-'=>'Unable to fetch fields');
			}else {
				$connector = $connection['success'];
				$fields = $connector->field_index();
			}


		echo '<p>';
		echo '<label >URL Update-Seite</label>';
		echo '<input type="text" class="regular-text code ktm-update-page-url">';
		echo '</p>';

		echo '<p>';
		echo '<label>Letzte Spalte Name</label>';
		echo '<input type="text" class="regular-text code ktm-last-column-label">';
		echo '</p>';

		echo '<p>';
		echo '<label>Letzte Spalte Feld</label>';
		echo '<select  class="ktm-last-column-field">';
		echo '<option value="">Auswählen</option>';
		foreach (  $fields as $fieldkey=>$field ) {
			echo '<option value="'.$fieldkey.'">'.$field.'</option>';
		}
		echo '</select>';
		echo '</p>';
?>

            <p>
                <input type="button" id="nf-insert-form" class="button-primary" value="<?php _e( 'Einfügen', 'ktm' )?>" />
			</p>
			</div>
        </div>
        <?php
		add_action( 'admin_footer', array( $this, 'output_tinymce_button_js' ) );
		return $context . ' ' . $html;
	}

	/**
	 * Output our tinyMCE field buttons
	 *
	 * @access public
	 * @since 2.8
	 * @return void
	 */
	public function output_tinymce_button_js( $context ) {
?>
        <script type="text/javascript">
            jQuery( document ).ready( function( $ ) {

				jQuery(document).on('click', '.ktm-insert-form', function () {
					tb_show("Klick-Tipp Manager einfügen", "#TB_inline?inlineId=ktm-insert-form-modal&width=553&height=250", "");
				})
                jQuery( document ).on( 'click', '#nf-insert-form', function( e ) {
                    e.preventDefault();
					var ktm_update_page_url = jQuery( '.ktm-update-page-url' ).val();
					var ktm_last_col_label = jQuery( '.ktm-last-column-label' ).val();
					var ktm_last_col_field = jQuery( '.ktm-last-column-field' ).val();
					var ktm_table_password = jQuery( '.ktm-table-password' ).val();
					var shortcode = '[klicktipp-manager';
					if( ktm_update_page_url !='' ){
						shortcode += ' updatepage="' + ktm_update_page_url+'"';
					}
					if( ktm_last_col_label !='' ){
						shortcode += ' lastcolumn="' + ktm_last_col_label;
						shortcode += ':'+ktm_last_col_field+'"';
					}
					if( ktm_table_password !='' ){
						shortcode += ' password="' + ktm_table_password+'"';
					}
					shortcode +=']';
                    window.parent.send_to_editor( shortcode );

                } );
            } );
        </script>

        <?php
	}
}
new GF_KTM_Premium_Editor_Btn();